searchData={"items":[{"type":"module","title":"ExClockBoundClient","doc":"The elixir version of aws clock bound client.","ref":"ExClockBoundClient.html"},{"type":"function","title":"ExClockBoundClient.after?/1","doc":"Returns true if the provided timestamp is after the latest error bound. Otherwise, returns false.","ref":"ExClockBoundClient.html#after?/1"},{"type":"function","title":"DateTime Format - ExClockBoundClient.after?/1","doc":"The `datetime` argument could be one of :\n- a DateTime struct.\n- a tuple of the form `{unix_time, unit}`. `unix_time` is an integer in unit, and `unit` is one of `:second`, `:millisecond`, `:microsecond`, or `:nanosecond`.","ref":"ExClockBoundClient.html#after?/1-datetime-format"},{"type":"function","title":"Examples - ExClockBoundClient.after?/1","doc":"iex> ExClockBoundClient.before?(~U[2024-02-01 11:14:57.656524Z])\n    {:ok, true}","ref":"ExClockBoundClient.html#after?/1-examples"},{"type":"function","title":"ExClockBoundClient.before?/1","doc":"Returns true if the provided timestamp is before the earliest error bound. Otherwise, returns false.","ref":"ExClockBoundClient.html#before?/1"},{"type":"function","title":"DateTime Format - ExClockBoundClient.before?/1","doc":"See `DateTime Format` in `after?/1` .","ref":"ExClockBoundClient.html#before?/1-datetime-format"},{"type":"function","title":"Examples - ExClockBoundClient.before?/1","doc":"iex> ExClockBoundClient.before?(~U[2024-02-01 11:14:57.656524Z])\n    {:ok, true}","ref":"ExClockBoundClient.html#before?/1-examples"},{"type":"function","title":"ExClockBoundClient.deviation/0","doc":"Returns the deviation in nanosecond of the current system time from the chrony server.","ref":"ExClockBoundClient.html#deviation/0"},{"type":"function","title":"Examples - ExClockBoundClient.deviation/0","doc":"iex> ExClockBoundClient.deviation()\n    {:ok, 1314}","ref":"ExClockBoundClient.html#deviation/0-examples"},{"type":"function","title":"ExClockBoundClient.now/0","doc":"Returns the bounds of the current system time +/- the error calculated from chrony.","ref":"ExClockBoundClient.html#now/0"},{"type":"function","title":"Examples - ExClockBoundClient.now/0","doc":"iex> ExClockBoundClient.now()\n    {:ok, {~U[2024-02-01 11:14:57.656524Z], ~U[2024-02-01 11:14:57.706487Z]}}","ref":"ExClockBoundClient.html#now/0-examples"},{"type":"function","title":"ExClockBoundClient.timing/2","doc":"Execute `function` and return bounds on execution time.\n\nIf the function execute correctly, it will return `{:ok, {time_bounds, execute_range}, result}` tuple.\n\n**Attention:** If the function raises or throws something, it will be treated as normal. And the result will be {:raise, inspect(exception)} or {:throw, inspect(anything)} .","ref":"ExClockBoundClient.html#timing/2"},{"type":"function","title":"Options - ExClockBoundClient.timing/2","doc":"- `exec_timeout` - The maximum time in milliseconds to wait for the function to complete. Default is 5000.","ref":"ExClockBoundClient.html#timing/2-options"},{"type":"function","title":"Examples - ExClockBoundClient.timing/2","doc":"iex> ExClockBoundClient.timing(fn -> :timer.sleep(1000) end)\n    {:ok, {{~U[2024-02-01 11:14:57.656524Z], ~U[2024-02-01 11:14:57.706487Z]}, {1011, 1033}}, :ok}","ref":"ExClockBoundClient.html#timing/2-examples"},{"type":"type","title":"ExClockBoundClient.nanosecond/0","doc":"","ref":"ExClockBoundClient.html#t:nanosecond/0"},{"type":"type","title":"ExClockBoundClient.unix_time_with_unit/0","doc":"","ref":"ExClockBoundClient.html#t:unix_time_with_unit/0"},{"type":"extras","title":"ExClockBoundClient","doc":"# ExClockBoundClient\n![Hex.pm Version](https://img.shields.io/hexpm/v/ex_clock_bound_client)\n![Hex.pm License](https://img.shields.io/hexpm/l/ex_clock_bound_client)\n\nThis is the elixir version of [aws clock bound client](https://github.com/aws/clock-bound/tree/main/clock-bound-c), to communicate with [this service](https://github.com/aws/clock-bound).","ref":"readme.html"},{"type":"extras","title":"Preparation - ExClockBoundClient","doc":"Make sure the service is running correctly.","ref":"readme.html#preparation"},{"type":"extras","title":"Installation - ExClockBoundClient","doc":"By adding `ex_clock_bound_client` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_clock_bound_client, \"~> 0.0.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - ExClockBoundClient","doc":"#","ref":"readme.html#usage"},{"type":"extras","title":"Runtime Configurations - ExClockBoundClient","doc":"All configurations are runtime configuration, and have default values.\n\n```elixir\nimport Config\n\nconfig :ex_clock_bound_client,\n  clock_bound_socket_path: \"/run/clockboundd/clockboundd.sock\",\n  client_socket_path: Path.expand(\"./client.sock\"),\n  recv_timeout: 100, # socket recv timeout\n  frequency_error: 1 # Setting clock frequency to 1ppm to match chrony\n```\n\n#","ref":"readme.html#runtime-configurations"},{"type":"extras","title":"APIs - ExClockBoundClient","doc":"There are 5 APIs in this library, and additional `deviation/0` are added compared to the [official client](https://github.com/aws/clock-bound/tree/main/clock-bound-c).\n\n- `ExCloudBoundClient.now/0`\n- `ExCloudBoundClient.timing/1`\n- `ExCloudBoundClient.deviation/0`\n- `ExCloudBoundClient.before?/1`\n- `ExCloudBoundClient.after?/1`\n\nSee [`t:ExClockBoundClient`](https://hexdocs.pm/ex_clock_bound_client/ExClockBoundClient.html) for details.","ref":"readme.html#apis"},{"type":"extras","title":"Todo - ExClockBoundClient","doc":"This application is just implement a happy path, all exceptions need to be considered.","ref":"readme.html#todo"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2024 Kenton Wang\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/markdown"}